static const char *RcsId = "$Id: KChannelSwitch.cpp,v 1.2 2012-05-15 10:06:45 xavela Exp $";
//+=============================================================================
//
// file :         KChannelSwitch.cpp
//
// description :  C++ source for the KChannelSwitch and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                KChannelSwitch are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: xavela $
//
// $Revision: 1.2 $
//
// $Revision: 1.2 $
// $Date: 2012-05-15 10:06:45 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /users/chaize/newsvn/cvsroot/Instrumentation/KChannelSwitch/src/KChannelSwitch.cpp,v $
// $Log: not supported by cvs2svn $
//
// copyleft :    Synchrotron SOLEIL 
//               L'Orme des merisiers - Saint Aubin
//               BP48 - 91192 Gif sur Yvette
//               FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name      |  Method name
//	----------------------------------------
//  State             |  dev_state()
//  Status            |  dev_status()
//  CloseAllChannels  |  close_all_channels()
//  OpenAllChannels   |  open_all_channels()
//
//===================================================================


#include <tango.h>
#include <KChannelSwitch.h>
#include <KChannelSwitchClass.h>
#include <yat4tango/InnerAppender.h>

static const unsigned short MAX_CONNECTED_SLOT = 2; //- Keithley 7001 max slots 

namespace KChannelSwitch_ns
{

//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::KChannelSwitch(string &s)
// 
// description : 	constructor for simulated KChannelSwitch
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
KChannelSwitch::KChannelSwitch(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

KChannelSwitch::KChannelSwitch(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

KChannelSwitch::KChannelSwitch(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::delete_device()
{
	//	Delete device allocated objects

  if ( _kSwitch )
  {
    //- memorise opened slot and channel numbers (to restore them at init !)
    unsigned short slotNum = this->_kSwitch->GetActiveSlotNumber();
    unsigned short chanNum = this->_kSwitch->GetActiveChannel();
    store_value_as_property(slotNum,"__MemorizedSlotNumber");
    store_value_as_property(chanNum,"__MemorizedChannelNumber");

    INFO_STREAM << " MEMORISED slot : " << slotNum << " & channel = " << chanNum << std::endl;

    //- release memory
    delete _kSwitch;
    _kSwitch = 0;
  }

	//- remove attributes from dam
	if ( _dam )
	{
		_dam->remove_attributes();
		delete _dam;
		_dam = 0;
	}
	INFO_STREAM << "Scalar(s) dynamic attribute(s) removed." << std::endl;
	
	//- remove the inner-appender
	yat4tango::InnerAppender::release(this);
	INFO_STREAM << "Inner-appender removed." << std::endl;
}

//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::init_device()
{
	INFO_STREAM << "KChannelSwitch::KChannelSwitch() create device " << device_name << endl;

  this->_kSwitch                 = 0;
  this->nbConnectedSlot          = 1;   //- default slot number
	this->_dam                     = 0;   //- dyn attr manager
  this->__memorizedSlotNumber    = 0;   //- memorized slot number
  this->__memorizedChannelNumber = 0;   //- memorized channel number

  // Initialise variables to default values
	//--------------------------------------------
	//- instanciate the appender in order to manage logs
	try
	{
		//- specify both the associated device and the log buffer depth
		INFO_STREAM << "Create the inner-appender in order to manage logs." << std::endl;
		yat4tango::InnerAppender::initialize(this, 512);
	}
	catch( Tango::DevFailed& df )
	{
		ERROR_STREAM << df << endl;
		this->set_state(Tango::ALARM);
		this->set_status("Initialization Failed :  could not instanciate the InnerAppender, caught a DevFailed ! ");
		return;
	}
	catch(...)
	{
		ERROR_STREAM << "Initialization Failed :  could not instanciate the InnerAppender, caught [...] ! " << endl;
		this->set_state(Tango::ALARM);
		this->set_status("Initialization Failed :  could not instanciate the InnerAppender, caught [...] ! ");
		return;
	}

  get_device_property();

  try
  {
    _kSwitch = new K7001(this, this->gpibDeviceName);
    _kSwitch->SetNbConnectedSlots(this->nbConnectedSlot);
  }
  catch(std::bad_alloc& bd)
  {
    FATAL_STREAM << "KChannelSwitch::init_device() FAILED(bad_alloc) : \n" << bd.what() << std::endl;
    if ( _kSwitch )
    {
      delete _kSwitch;
      _kSwitch = 0;
    }
    set_state(Tango::FAULT);
		return;
  }
  catch(Tango::DevFailed& df)
  {
    FATAL_STREAM << "KChannelSwitch::init_device() FAILED(DevFailed) : : _kSwitch = " << _kSwitch << " : \n" << df << std::endl;
    if ( _kSwitch )
    {
      delete _kSwitch;
      _kSwitch = 0;
    }
    set_state(Tango::FAULT);
    set_status("KChannelSwitch::init_device() FAILED(DevFailed) : see log(s) for details.");
		return;
  }
  catch(...)
  {
    if ( _kSwitch )
    {
      delete _kSwitch;
      _kSwitch = 0;
    }
    FATAL_STREAM << "KChannelSwitch::init_device() FAILED(...) : _kSwitch = " << _kSwitch << std::endl;
    set_state(Tango::FAULT);
    set_status("KChannelSwitch::init_device() FAILED(DevFailed) : see log(s) for details.");
		return;
  }

  //- create dyn attr "slotNumber"
  if ( this->nbConnectedSlot == MAX_CONNECTED_SLOT )
  {
    this->create_dynamic_attribute();
  }

	try
	{
    INFO_STREAM << "KChannelSwitch::init_device() slot num : " 
      << __memorizedSlotNumber
      << " and channel num : "
      << __memorizedChannelNumber
      << " TO TRY !"
      << std::endl;
		//- TRICK : restore memorized attribute(s) value
		this->restore_saved_properties();
    attr_inputChannelNumber_write = this->_kSwitch->GetActiveChannel();
	}
	catch(Tango::DevFailed& df)
	{
		set_state(Tango::FAULT);
		set_status("init_device caught DevFailed : failed to set memorized attributes values !!");
		FATAL_STREAM << "init_device caught DevFailed : failed to set memorized attributes values !!" << std::endl;
		FATAL_STREAM << df << std::endl;
		return;
	}
	catch(...)
	{
		set_state(Tango::FAULT);
		set_status("init_device caught [...] : failed to set memorized attributes values !!");
		FATAL_STREAM << "init_device caught [...] : failed to set memorized attributes values !!" << std::endl;
		return;
	}

  INFO_STREAM << "INIT DEV DONE : attr_inputChannelNumber_write = " << attr_inputChannelNumber_write << std::endl;
}


//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::get_device_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------
  gpibDeviceName = "noGPIB/Device/Defined";
  nbConnectedSlot= 1;

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("GpibDeviceName"));
	dev_prop.push_back(Tango::DbDatum("NbConnectedSlot"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	KChannelSwitchClass	*ds_class =
		(static_cast<KChannelSwitchClass *>(get_device_class()));
	int	i = -1;

	//	Try to initialize GpibDeviceName from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  gpibDeviceName;
	else {
		//	Try to initialize GpibDeviceName from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  gpibDeviceName;
	}
	//	And try to extract GpibDeviceName value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  gpibDeviceName;

	//	Try to initialize NbConnectedSlot from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  nbConnectedSlot;
	else {
		//	Try to initialize NbConnectedSlot from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  nbConnectedSlot;
	}
	//	And try to extract NbConnectedSlot value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  nbConnectedSlot;



	//	End of Automatic code generation
	//------------------------------------------------------------------
	//- Creates default property
	Tango::DbData data_put;
	if ( dev_prop[0].is_empty() )
	{
		Tango::DbDatum  prop("GpibDeviceName");
		prop  <<  gpibDeviceName;
		data_put.push_back(prop);
	}
	if ( dev_prop[1].is_empty() )
	{
		Tango::DbDatum  prop("NbConnectedSlot");
		prop  <<  nbConnectedSlot;
		data_put.push_back(prop);
	}
	
	//- write default property if created
	if( !data_put.empty() )
		get_db_device()->put_property(data_put);

}
//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void KChannelSwitch::always_executed_hook()
{
	
}
//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "KChannelSwitch::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}
//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::read_inputChannelNumber
// 
// description : 	Extract real attribute values for inputChannelNumber acquisition result.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::read_inputChannelNumber(Tango::Attribute &attr)
{
	DEBUG_STREAM << "KChannelSwitch::read_inputChannelNumber(Tango::Attribute &attr) entering... "<< endl;
  
  if ( !this->_kSwitch  )
  {
    attr.set_quality(Tango::ATTR_INVALID);
    Tango::Except::throw_exception(
			    (const char*)("INIT_ERROR"),
			    (const char*)("device is not properly initialized"),
			    (const char*)("KChannelSwitch::read_inputChannelNumber"));
  }

  try
  {
    //- get opened input channel
    unsigned short openedCh = this->_kSwitch->GetActiveChannel();
    attr.set_value(&openedCh);
    //- if slot number has been changed and its slot is not opened -> WARN !!!
    if ( !openedCh || !this->_kSwitch->isChannelOpened(openedCh) )
      attr.set_quality(Tango::ATTR_ALARM);
  }
  catch(Tango::DevFailed& df)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    ERROR_STREAM << "KChannelSwitch::read_inputChannelNumber caught a DevFailed exception :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
			    (const char*)("COMMUNICATION_ERROR"),
          (const char*)("Failed to read channel value : check GPIB communication !"),
			    (const char*)("KChannelSwitch::read_inputChannelNumber"));
  }
  catch(...)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    ERROR_STREAM << "KChannelSwitch::read_inputChannelNumber caught a generic exception." << std::endl;
    Tango::Except::throw_exception(
      (const char*)("COMMUNICATION_ERROR"),
      (const char*)("Failed to read channel value : check GPIB communication !"),
      (const char*)("KChannelSwitch::read_inputChannelNumber"));
 }
}

//+----------------------------------------------------------------------------
//
// method : 		KChannelSwitch::write_inputChannelNumber
// 
// description : 	Write inputChannelNumber attribute values to hardware.
//
//-----------------------------------------------------------------------------
void KChannelSwitch::write_inputChannelNumber(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "KChannelSwitch::write_inputChannelNumber(Tango::WAttribute &attr) entering... "<< endl;
  
  if ( !this->_kSwitch  )
  {
    Tango::Except::throw_exception(
			    (const char*)("INIT_ERROR"),
			    (const char*)("device is not properly initialized"),
			    (const char*)("KChannelSwitch::write_channelNumber"));
  }

  //- HERMES specification :
  try
  {
    //- get opened input channel
    unsigned short openedCh = this->_kSwitch->GetActiveChannel();
    //- close previous channel
    //this->_kSwitch->CloseChannel(attr_inputChannelNumber_write);
    if ( openedCh )
      this->_kSwitch->CloseChannel(openedCh);
    //- Open the new one 
    attr.get_write_value(attr_inputChannelNumber_write);
    this->_kSwitch->OpenChannel(attr_inputChannelNumber_write);
  }
  catch(Tango::DevFailed& df)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    ERROR_STREAM << "KChannelSwitch::write_inputChannelNumber caught a DevFailed exception :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
			    (const char*)("COMMUNICATION_ERROR"),
          (const char*)("Failed to write new channel value : check GPIB communication !"),
			    (const char*)("KChannelSwitch::write_channelNumber"));
  }
  catch(...)
  {
    attr.set_quality(Tango::ATTR_INVALID);
    ERROR_STREAM << "KChannelSwitch::write_inputChannelNumber caught a generic exception." << std::endl;
    Tango::Except::throw_exception(
      (const char*)("COMMUNICATION_ERROR"),
      (const char*)("Failed to write new channel value : check GPIB communication !"),
      (const char*)("KChannelSwitch::write_channelNumber"));
 }
}

//+------------------------------------------------------------------
/**
 *	method:	KChannelSwitch::dev_state
 *
 *	description:	method to execute "State"
 *	This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 * @return	State Code
 *
 */
//+------------------------------------------------------------------
Tango::DevState KChannelSwitch::dev_state()
{
	Tango::DevState	argout = DeviceImpl::dev_state();
	DEBUG_STREAM << "KChannelSwitch::dev_state(): entering... !" << endl;

	//	Add your own code to control device here
  if ( !this->_kSwitch )
  {
    argout = Tango::FAULT;
    set_status("KChannelSwitch::dev_state -> Device initialization failed !");
  }
  else
  {
    try
    {
      //- get Keithley Swicth System status
      std::string status = this->_kSwitch->GetStatus();
      if ( status.find("No error") == std::string::npos )
        argout = Tango::ALARM;
      else
        argout = Tango::ON;
      //- set the new status
      set_status(status.c_str());
    }
    catch(Tango::DevFailed& df)
    {
      set_state(Tango::FAULT);
      set_status("KChannelSwitch::dev_state -> caught a DevFailed exception !");
      ERROR_STREAM << "KChannelSwitch::dev_state caught a DevFailed exception :\n" << df << std::endl;
      Tango::Except::re_throw_exception(df,
        (const char*)("COMMUNICATION_ERROR"),
        (const char*)("Failed to get Keithley device state/status : check GPIB communication !"),
        (const char*)("KChannelSwitch::dev_state"));
    }
    catch(...)
    {
      set_state(Tango::FAULT);
      set_status("KChannelSwitch::dev_state -> caught a generic exception !");
      ERROR_STREAM << "KChannelSwitch::dev_state caught a generic exception." << std::endl;
      Tango::Except::throw_exception(
        (const char*)("COMMUNICATION_ERROR"),
        (const char*)("Failed to get Keithley device state/status : check GPIB communication !"),
        (const char*)("KChannelSwitch::dev_state"));
    }
  }

	set_state(argout);
	return argout;
}

//====================================================
//            -   INTERNAL METHODS    -
//====================================================
void KChannelSwitch::create_dynamic_attribute()
{
	try
	{
		INFO_STREAM << "Creating Slot number attribute ..." << std::endl;
		yat4tango::DynamicAttributeInfo dynAttrInfo;

		dynAttrInfo.dev = this;
		//- dyn attr description
		dynAttrInfo.tai.name        = "slotNumber";
		dynAttrInfo.tai.data_type   = Tango::DEV_USHORT;
		dynAttrInfo.tai.data_format = Tango::SCALAR;
		dynAttrInfo.tai.writable    = Tango::READ_WRITE;
		dynAttrInfo.tai.disp_level  = Tango::OPERATOR;
		//- cleanup tango db option: cleanup tango db when removing this dyn. attr. (i.e. erase its properties fom db)
		dynAttrInfo.cdb = true;
    //- read callback
    dynAttrInfo.rcb = yat4tango::DynamicAttributeReadCallback::instanciate(*this,
      &KChannelSwitch::read_slotNumber_callback);
		//- write callback
		dynAttrInfo.wcb = yat4tango::DynamicAttributeWriteCallback::instanciate(*this, 
			&KChannelSwitch::write_slotNumber_callback);

		//- add the attribute to the dam
		this->_dam = new yat4tango::DynamicAttributeManager(this);
		this->_dam->add_attribute(dynAttrInfo);
	}
	catch(...)
	{
    ERROR_STREAM << "Failed to create \"slotNumber\" attribute !" << std::endl;
    if ( this->_dam )
    {
      delete this->_dam;
      this->_dam = 0;
    }
	}
}

void KChannelSwitch::read_slotNumber_callback(yat4tango::DynamicAttributeReadCallbackData& cbd)
{
	DEBUG_STREAM << "read request for slotNumber dynamic attribute: " 
		<< cbd.dya->get_name()
		<< std::endl;

  try
  {
    unsigned short slotNumber = this->_kSwitch->GetActiveSlotNumber();
    cbd.tga->set_value(&slotNumber);
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "KChannelSwitch::read_slotNumber_callback caught a DevFailed exception :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
			    (const char*)("COMMUNICATION_ERROR"),
          (const char*)("Failed to read slot value : check GPIB communication !"),
			    (const char*)("KChannelSwitch::read_slotNumber_callback"));
  }
  catch(...)
  {
    ERROR_STREAM << "KChannelSwitch::read_slotNumber_callback caught a generic exception." << std::endl;
    Tango::Except::throw_exception(
      (const char*)("COMMUNICATION_ERROR"),
      (const char*)("Failed to read slot value : check GPIB communication !"),
      (const char*)("KChannelSwitch::read_slotNumber_callback"));
 }

}

void KChannelSwitch::write_slotNumber_callback(yat4tango::DynamicAttributeWriteCallbackData& cbd)
{
	DEBUG_STREAM << "write request for slotNumber dynamic attribute: " 
		<< cbd.dya->get_name()
		<< std::endl;

  try
  {
    unsigned short slotNumber = 0;
    cbd.tga->get_write_value(slotNumber);

    this->_kSwitch->SetActiveSlotNumber(slotNumber);
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "KChannelSwitch::write_slotNumber_callback caught a DevFailed exception :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
			    (const char*)("COMMUNICATION_ERROR"),
          (const char*)("Failed to write slot value : check GPIB communication !"),
			    (const char*)("KChannelSwitch::write_slotNumber_callback"));
  }
  catch(...)
  {
    ERROR_STREAM << "KChannelSwitch::write_slotNumber_callback caught a generic exception." << std::endl;
    Tango::Except::throw_exception(
      (const char*)("COMMUNICATION_ERROR"),
      (const char*)("Failed to write slot value : check GPIB communication !"),
      (const char*)("KChannelSwitch::write_slotNumber_callback"));
 }
}

//+------------------------------------------------------------------
/**
  *	method:	KChannelSwitch::store_value_as_property
  *
  *	description:	store current value in a device property
  */
//+------------------------------------------------------------------
template <class T>
void KChannelSwitch::store_value_as_property(T value,std::string property_name)
{
	Tango::DbDatum current_value(property_name);
  current_value << value;
  Tango::DbData db_data;
  db_data.push_back(current_value);

  try
  {
    get_db_device()->put_property(db_data);
  }
  catch(Tango::DevFailed &df)
  {     
    FATAL_STREAM << df << endl;

    set_state(Tango::FAULT);
    set_status("can't store value in the database");
    throw df;
  }
}

//+------------------------------------------------------------------
/**
*	method:	KChannelSwitch::restore_saved_properties
*
*	description:	restore attribute value stored in a device property
*/
//+------------------------------------------------------------------
void KChannelSwitch::restore_saved_properties(void)
{
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("__MemorizedSlotNumber"));
	dev_prop.push_back(Tango::DbDatum("__MemorizedChannelNumber"));

	//-	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);

  size_t idx = 0;
	//-	Try to extract saved property from database
	if (dev_prop[idx].is_empty()==false)
	{
		dev_prop[idx++]  >>  __memorizedSlotNumber;
  }

	if (dev_prop[idx].is_empty()==false)
	{
		dev_prop[idx++]  >>  __memorizedChannelNumber;
	}

  try
  {
    //- (re)apply values
    if ( this->_kSwitch )
    {
      this->_kSwitch->SetActiveSlotNumber(__memorizedSlotNumber);
      INFO_STREAM << "KChannelSwitch::restore_saved_properties : (@" 
        << __memorizedSlotNumber 
        << "!"
        << __memorizedChannelNumber
        << ")"
        << std::endl;
      //- Open the specified input channel
      this->_kSwitch->OpenChannel(__memorizedChannelNumber);
    }
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "KChannelSwitch::restore_saved_properties caught a DevFailed exception :\n" << df << std::endl;
    Tango::Except::re_throw_exception(df,
			    (const char*)("COMMUNICATION_ERROR"),
          (const char*)("Failed to restore saved properties : check GPIB communication !"),
			    (const char*)("KChannelSwitch::restore_saved_properties"));
  }
  catch(...)
  {
    ERROR_STREAM << "KChannelSwitch::restore_saved_properties caught a generic exception." << std::endl;
    Tango::Except::throw_exception(
      (const char*)("COMMUNICATION_ERROR"),
      (const char*)("Failed to restore saved properties : check GPIB communication !"),
      (const char*)("KChannelSwitch::restore_saved_properties"));
 }
}


//+------------------------------------------------------------------
/**
 *	method:	KChannelSwitch::close_all_channels
 *
 *	description:	method to execute "CloseAllChannels"
 *	Command to close all input channels.
 *
 *
 */
//+------------------------------------------------------------------
void KChannelSwitch::close_all_channels()
{
	DEBUG_STREAM << "KChannelSwitch::close_all_channels(): entering... !" << endl;

	//	Add your own code to control device here

}

//+------------------------------------------------------------------
/**
 *	method:	KChannelSwitch::open_all_channels
 *
 *	description:	method to execute "OpenAllChannels"
 *	Command to open all input channels.
 *
 *
 */
//+------------------------------------------------------------------
void KChannelSwitch::open_all_channels()
{
	DEBUG_STREAM << "KChannelSwitch::open_all_channels(): entering... !" << endl;

	//	Add your own code to control device here

}


}	//	namespace
